HybridDate (ORC Core 1.6.6 API)
Date: 2021-01-13

org.threeten.extra.chrono

## Class HybridDate

- java.lang.Object
- - org.threeten.extra.chrono.HybridDate

- All Implemented Interfaces:
    Serializable, Comparable<ChronoLocalDate>, ChronoLocalDate, Temporal, TemporalAccessor, TemporalAdjuster

      public final class HybridDate
      extends Object
      implements ChronoLocalDate, Serializable

  A date in the British Cutover calendar system.

  This date operates using the British Cutover calendar.

  ### Implementation Requirements

  This class is immutable and thread-safe.

  This class must be treated as a value type. Do not synchronize, rely on the identity hash code or use the distinction between equals() and ==.

  See Also:
    Serialized Form

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ChronoLocalDateTime<HybridDate>` | `atTime(LocalTime localTime)`
    `boolean` | `equals(Object obj)`
    `static HybridDate` | `from(TemporalAccessor temporal)` Obtains a `HybridDate` from a temporal object.
    `HybridChronology` | `getChronology()` Gets the chronology of this date, which is the British Cutover calendar system.
    `JulianEra` | `getEra()` Gets the era applicable at this date.
    `long` | `getLong(TemporalField arg0)`
    `int` | `hashCode()` A hash code for this date.
    `int` | `lengthOfMonth()` Returns the length of the month represented by this date.
    `int` | `lengthOfYear()` Returns the length of the year represented by this date.
    `HybridDate` | `minus(long amountToSubtract, TemporalUnit unit)`
    `HybridDate` | `minus(TemporalAmount amount)`
    `static HybridDate` | `now()` Obtains the current `HybridDate` from the system clock in the default time-zone.
    `static HybridDate` | `now(Clock clock)` Obtains the current `HybridDate` from the specified clock.
    `static HybridDate` | `now(ZoneId zone)` Obtains the current `HybridDate` from the system clock in the specified time-zone.
    `static HybridDate` | `of(int prolepticYear, int month, int dayOfMonth)` Obtains a `HybridDate` representing a date in the British Cutover calendar system from the proleptic-year, month-of-year and day-of-month fields.
    `HybridDate` | `plus(long amountToAdd, TemporalUnit unit)`
    `HybridDate` | `plus(TemporalAmount amount)`
    `<R> R` | `query(TemporalQuery<R> query)`
    `ValueRange` | `range(TemporalField arg0)`
    `ValueRange` | `rangeChrono(ChronoField field)`
    `long` | `toEpochDay()`
    `String` | `toString()`
    `ChronoPeriod` | `until(ChronoLocalDate endDateExclusive)`
    `long` | `until(Temporal endExclusive, TemporalUnit unit)`
    `HybridDate` | `with(TemporalAdjuster adjuster)`
    `HybridDate` | `with(TemporalField field, long newValue)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.time.chrono.ChronoLocalDate

      `adjustInto, compareTo, format, isAfter, isBefore, isEqual, isLeapYear, isSupported, isSupported, timeLineOrder, toString`

    - ### Methods inherited from interface java.time.temporal.TemporalAccessor

      `get, getLong, range`

- - ### Method Detail

    - #### now

          public static HybridDate now()

      Obtains the current `HybridDate` from the system clock in the default time-zone.

      This will query the `system clock` in the default time-zone to obtain the current date.

      Using this method will prevent the ability to use an alternate clock for testing because the clock is hard-coded.

      Returns:
        the current date using the system clock and default time-zone, not null

    - #### now

          public static HybridDate now(ZoneId zone)

      Obtains the current `HybridDate` from the system clock in the specified time-zone.

      This will query the `system clock` to obtain the current date. Specifying the time-zone avoids dependence on the default time-zone.

      Using this method will prevent the ability to use an alternate clock for testing because the clock is hard-coded.

      Parameters:
        `zone` - the zone ID to use, not null
      Returns:
        the current date using the system clock, not null

    - #### now

          public static HybridDate now(Clock clock)

      Obtains the current `HybridDate` from the specified clock.

      This will query the specified clock to obtain the current date - today. Using this method allows the use of an alternate clock for testing. The alternate clock may be introduced using dependency injection.

      Parameters:
        `clock` - the clock to use, not null
      Returns:
        the current date, not null
      Throws:
        `DateTimeException` - if the current date cannot be obtained

    - #### of

          public static HybridDate of(int prolepticYear,
                                      int month,
                                      int dayOfMonth)

      Obtains a `HybridDate` representing a date in the British Cutover calendar system from the proleptic-year, month-of-year and day-of-month fields.

      This returns a `HybridDate` with the specified fields.

      Dates in the middle of the cutover gap, such as the 10th September 1752, will not throw an exception. Instead, the date will be treated as a Julian date and converted to an ISO date, with the day of month shifted by 11 days.

      Invalid dates, such as September 31st will throw an exception.

      Parameters:
        `prolepticYear` - the British Cutover proleptic-year
        `month` - the British Cutover month-of-year, from 1 to 12
        `dayOfMonth` - the British Cutover day-of-month, from 1 to 31
      Returns:
        the date in British Cutover calendar system, not null
      Throws:
        `DateTimeException` - if the value of any field is out of range, or if the day-of-month is invalid for the month-year

    - #### from

          public static HybridDate from(TemporalAccessor temporal)

      Obtains a `HybridDate` from a temporal object.

      This obtains a date in the British Cutover calendar system based on the specified temporal. A `TemporalAccessor` represents an arbitrary set of date and time information, which this factory converts to an instance of `HybridDate`.

      The conversion uses the `EPOCH_DAY` field, which is standardized across calendar systems.

      This method matches the signature of the functional interface `TemporalQuery` allowing it to be used as a query via method reference, `HybridDate::from`.

      Specified by:
        `from` in interface `ChronoLocalDate`
      Parameters:
        `temporal` - the temporal object to convert, not null
      Returns:
        the date in British Cutover calendar system, not null
      Throws:
        `DateTimeException` - if unable to convert to a `HybridDate`

    - #### rangeChrono

          public ValueRange rangeChrono(ChronoField field)

    - #### getChronology

          public HybridChronology getChronology()

      Gets the chronology of this date, which is the British Cutover calendar system.

      The `Chronology` represents the calendar system in use. The era and other fields in `ChronoField` are defined by the chronology.

      Specified by:
        `getChronology` in interface `ChronoLocalDate`
      Returns:
        the British Cutover chronology, not null

    - #### getEra

          public JulianEra getEra()

      Gets the era applicable at this date.

      The British Cutover calendar system has two eras, 'AD' and 'BC', defined by `JulianEra`.

      Specified by:
        `getEra` in interface `ChronoLocalDate`
      Returns:
        the era applicable at this date, not null

    - #### lengthOfMonth

          public int lengthOfMonth()

      Returns the length of the month represented by this date.

      This returns the length of the month in days. This takes into account the cutover, returning 19 in September 1752.

      Specified by:
        `lengthOfMonth` in interface `ChronoLocalDate`
      Returns:
        the length of the month in days, from 19 to 31

    - #### lengthOfYear

          public int lengthOfYear()

      Returns the length of the year represented by this date.

      This returns the length of the year in days. This takes into account the cutover, returning 355 in 1752.

      Specified by:
        `lengthOfYear` in interface `ChronoLocalDate`
      Returns:
        the length of the month in days, from 19 to 31

    - #### with

          public HybridDate with(TemporalAdjuster adjuster)

      Specified by:
        `with` in interface `ChronoLocalDate`
      Specified by:
        `with` in interface `Temporal`

    - #### with

          public HybridDate with(TemporalField field,
                                 long newValue)

      Specified by:
        `with` in interface `ChronoLocalDate`
      Specified by:
        `with` in interface `Temporal`

    - #### plus

          public HybridDate plus(TemporalAmount amount)

      Specified by:
        `plus` in interface `ChronoLocalDate`
      Specified by:
        `plus` in interface `Temporal`

    - #### plus

          public HybridDate plus(long amountToAdd,
                                 TemporalUnit unit)

      Specified by:
        `plus` in interface `ChronoLocalDate`
      Specified by:
        `plus` in interface `Temporal`

    - #### minus

          public HybridDate minus(TemporalAmount amount)

      Specified by:
        `minus` in interface `ChronoLocalDate`
      Specified by:
        `minus` in interface `Temporal`

    - #### minus

          public HybridDate minus(long amountToSubtract,
                                  TemporalUnit unit)

      Specified by:
        `minus` in interface `ChronoLocalDate`
      Specified by:
        `minus` in interface `Temporal`

    - #### atTime

          public ChronoLocalDateTime<HybridDate> atTime(LocalTime localTime)

      Specified by:
        `atTime` in interface `ChronoLocalDate`

    - #### until

          public long until(Temporal endExclusive,
                            TemporalUnit unit)

      Specified by:
        `until` in interface `ChronoLocalDate`
      Specified by:
        `until` in interface `Temporal`

    - #### until

          public ChronoPeriod until(ChronoLocalDate endDateExclusive)

      Specified by:
        `until` in interface `ChronoLocalDate`

    - #### toEpochDay

          public long toEpochDay()

      Specified by:
        `toEpochDay` in interface `ChronoLocalDate`

    - #### query

          public <R> R query(TemporalQuery<R> query)

      Specified by:
        `query` in interface `ChronoLocalDate`
      Specified by:
        `query` in interface `TemporalAccessor`

    - #### equals

          public boolean equals(Object obj)

      Specified by:
        `equals` in interface `ChronoLocalDate`

    - #### hashCode

          public int hashCode()

      A hash code for this date.
      Specified by:
        `hashCode` in interface `ChronoLocalDate`
      Returns:
        a suitable hash code based only on the Chronology and the date

    - #### range

          public ValueRange range(TemporalField arg0)

      Specified by:
        `range` in interface `TemporalAccessor`

    - #### getLong

          public long getLong(TemporalField arg0)

      Specified by:
        `getLong` in interface `TemporalAccessor`

    - #### toString

          public String toString()

      Specified by:
        `toString` in interface `ChronoLocalDate`
      Overrides:
        `toString` in class `Object`

Copyright © 2013–2021 The Apache Software Foundation. All rights reserved.